// Code generated by github.com/actgardner/gogen-avro/v7. DO NOT EDIT.
/*
 * SOURCE:
 *     Record.avsc
 */
package gen

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/actgardner/gogen-avro/v7/vm"
	"github.com/actgardner/gogen-avro/v7/vm/types"
)

type MessageType int32

const (
	MessageTypeINSERT      MessageType = 0
	MessageTypeUPDATE      MessageType = 1
	MessageTypeDELETE      MessageType = 2
	MessageTypeDDL         MessageType = 3
	MessageTypeBEGIN       MessageType = 4
	MessageTypeCOMMIT      MessageType = 5
	MessageTypeHEARTBEAT   MessageType = 6
	MessageTypeCHECKPOINT  MessageType = 7
	MessageTypeROLLBACK    MessageType = 8
	MessageTypeSTATEMENT   MessageType = 9
	MessageTypeINIT_DDL    MessageType = 10
	MessageTypeINIT_INSERT MessageType = 11
)

func (e MessageType) String() string {
	switch e {
	case MessageTypeINSERT:
		return "INSERT"
	case MessageTypeUPDATE:
		return "UPDATE"
	case MessageTypeDELETE:
		return "DELETE"
	case MessageTypeDDL:
		return "DDL"
	case MessageTypeBEGIN:
		return "BEGIN"
	case MessageTypeCOMMIT:
		return "COMMIT"
	case MessageTypeHEARTBEAT:
		return "HEARTBEAT"
	case MessageTypeCHECKPOINT:
		return "CHECKPOINT"
	case MessageTypeROLLBACK:
		return "ROLLBACK"
	case MessageTypeSTATEMENT:
		return "STATEMENT"
	case MessageTypeINIT_DDL:
		return "INIT_DDL"
	case MessageTypeINIT_INSERT:
		return "INIT_INSERT"
	}
	return "unknown"
}

func writeMessageType(r MessageType, w io.Writer) error {
	return vm.WriteInt(int32(r), w)
}

func NewMessageTypeValue(raw string) (r MessageType, err error) {
	switch raw {
	case "INSERT":
		return MessageTypeINSERT, nil
	case "UPDATE":
		return MessageTypeUPDATE, nil
	case "DELETE":
		return MessageTypeDELETE, nil
	case "DDL":
		return MessageTypeDDL, nil
	case "BEGIN":
		return MessageTypeBEGIN, nil
	case "COMMIT":
		return MessageTypeCOMMIT, nil
	case "HEARTBEAT":
		return MessageTypeHEARTBEAT, nil
	case "CHECKPOINT":
		return MessageTypeCHECKPOINT, nil
	case "ROLLBACK":
		return MessageTypeROLLBACK, nil
	case "STATEMENT":
		return MessageTypeSTATEMENT, nil
	case "INIT_DDL":
		return MessageTypeINIT_DDL, nil
	case "INIT_INSERT":
		return MessageTypeINIT_INSERT, nil
	}

	return -1, fmt.Errorf("invalid value for MessageType: '%s'", raw)
}

func (b *MessageType) MarshalJSON() ([]byte, error) {
	return json.Marshal(b.String())
}

func (b *MessageType) UnmarshalJSON(data []byte) error {
	var stringVal string
	err := json.Unmarshal(data, &stringVal)
	if err != nil {
		return err
	}
	val, err := NewMessageTypeValue(stringVal)
	*b = val
	return err
}

type MessageTypeWrapper struct {
	Target *MessageType
}

func (b *MessageTypeWrapper) SetBoolean(v bool) {
	panic("Unable to assign boolean to int field")
}

func (b *MessageTypeWrapper) SetInt(v int32) {
	*(b.Target) = MessageType(v)
}

func (b *MessageTypeWrapper) SetLong(v int64) {
	panic("Unable to assign long to int field")
}

func (b *MessageTypeWrapper) SetFloat(v float32) {
	panic("Unable to assign float to int field")
}

func (b *MessageTypeWrapper) SetUnionElem(v int64) {
	panic("Unable to assign union elem to int field")
}

func (b *MessageTypeWrapper) SetDouble(v float64) {
	panic("Unable to assign double to int field")
}

func (b *MessageTypeWrapper) SetBytes(v []byte) {
	panic("Unable to assign bytes to int field")
}

func (b *MessageTypeWrapper) SetString(v string) {
	panic("Unable to assign string to int field")
}

func (b *MessageTypeWrapper) Get(i int) types.Field {
	panic("Unable to get field from int field")
}

func (b *MessageTypeWrapper) SetDefault(i int) {
	panic("Unable to set default on int field")
}

func (b *MessageTypeWrapper) AppendMap(key string) types.Field {
	panic("Unable to append map key to from int field")
}

func (b *MessageTypeWrapper) AppendArray() types.Field {
	panic("Unable to append array element to from int field")
}

func (b *MessageTypeWrapper) NullField(int) {
	panic("Unable to null field in int field")
}

func (b *MessageTypeWrapper) Finalize() {}
