// Code generated by github.com/actgardner/gogen-avro/v7. DO NOT EDIT.
/*
 * SOURCE:
 *     Record.avsc
 */
package gen

import (
	"github.com/actgardner/gogen-avro/v7/compiler"
	"github.com/actgardner/gogen-avro/v7/vm"
	"github.com/actgardner/gogen-avro/v7/vm/types"
	"io"
)

type Record struct {
	// unique id of this record in the whole stream
	Id int64 `json:"id"`
	// protocol version
	Version int32 `json:"version"`

	MessageType MessageType `json:"messageType"`
	// binlog file name
	FileName string `json:"fileName"`
	// record log timestamp
	Timestamp int64 `json:"timestamp"`

	Gtid string `json:"gtid"`
	// end_log_pos of last event (exclude commit) in transaction
	Position string `json:"position"`
	// end_log_pos of begin event in transaction
	SafePosition string `json:"safePosition"`
	// transaction id
	TransactionId string `json:"transactionId"`

	ServerId string `json:"serverId"`

	ThreadId string `json:"threadId"`
	// source database type
	SourceType string `json:"sourceType"`
	// source database version
	SourceVersion string `json:"sourceVersion"`
	// name of source schema if exist
	Field_SchemaName string `json:"schemaName"`
	// name of source table if exist
	TableName string `json:"tableName"`
	// schemaName.tableName
	ObjectName string `json:"objectName"`

	Columns *UnionNullArrayField `json:"columns"`
	// values of a row before modify
	OldColumns *UnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject `json:"oldColumns"`
	// values of a row after modify
	NewColumns *UnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject `json:"newColumns"`
	// ddl sql if this is a ddl event
	Sql string `json:"sql"`
	// execution time of ddl sql
	ExecutionTime int32 `json:"executionTime"`
	// timestamp of heartbeat send by master if this is a heartbeat record
	HeartbeatTimestamp int64 `json:"heartbeatTimestamp"`

	SyncedGtid string `json:"syncedGtid"`
	// for some database that has no gtid, a fake gtid will be assigned
	FakeGtid bool `json:"fakeGtid"`
	// primary keys
	PkNames []string `json:"pkNames"`
	// a millisecond timestamp. Not implemented at current version
	ReaderTimestamp int64 `json:"readerTimestamp"`
	// tags to identify properties of this record
	Tags map[string]string `json:"tags"`
	// Not implemented at current version
	Index int32 `json:"index"`
	// Not implemented at current version
	Total int32 `json:"total"`
	// bytes value of oldColumns when record is too large to split
	OldColumnsBytes []byte `json:"oldColumnsBytes"`
	// bytes value of newColumns when record is too large to split
	NewColumnsBytes []byte `json:"newColumnsBytes"`
}

const RecordAvroCRC64Fingerprint = "\xa6\x84\xbe\xfd\x83c\xb3*"

func NewRecord() *Record {
	return &Record{}
}

func DeserializeRecord(r io.Reader) (*Record, error) {
	t := NewRecord()
	deser, err := compiler.CompileSchemaBytes([]byte(t.Schema()), []byte(t.Schema()))
	if err != nil {
		return nil, err
	}

	err = vm.Eval(r, deser, t)
	if err != nil {
		return nil, err
	}
	return t, err
}

func DeserializeRecordFromSchema(r io.Reader, schema string) (*Record, error) {
	t := NewRecord()

	deser, err := compiler.CompileSchemaBytes([]byte(schema), []byte(t.Schema()))
	if err != nil {
		return nil, err
	}

	err = vm.Eval(r, deser, t)
	if err != nil {
		return nil, err
	}
	return t, err
}

func writeRecord(r *Record, w io.Writer) error {
	var err error
	err = vm.WriteLong(r.Id, w)
	if err != nil {
		return err
	}
	err = vm.WriteInt(r.Version, w)
	if err != nil {
		return err
	}
	err = writeMessageType(r.MessageType, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.FileName, w)
	if err != nil {
		return err
	}
	err = vm.WriteLong(r.Timestamp, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.Gtid, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.Position, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.SafePosition, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.TransactionId, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.ServerId, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.ThreadId, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.SourceType, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.SourceVersion, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.Field_SchemaName, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.TableName, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.ObjectName, w)
	if err != nil {
		return err
	}
	err = writeUnionNullArrayField(r.Columns, w)
	if err != nil {
		return err
	}
	err = writeUnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject(r.OldColumns, w)
	if err != nil {
		return err
	}
	err = writeUnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject(r.NewColumns, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.Sql, w)
	if err != nil {
		return err
	}
	err = vm.WriteInt(r.ExecutionTime, w)
	if err != nil {
		return err
	}
	err = vm.WriteLong(r.HeartbeatTimestamp, w)
	if err != nil {
		return err
	}
	err = vm.WriteString(r.SyncedGtid, w)
	if err != nil {
		return err
	}
	err = vm.WriteBool(r.FakeGtid, w)
	if err != nil {
		return err
	}
	err = writeArrayString(r.PkNames, w)
	if err != nil {
		return err
	}
	err = vm.WriteLong(r.ReaderTimestamp, w)
	if err != nil {
		return err
	}
	err = writeMapString(r.Tags, w)
	if err != nil {
		return err
	}
	err = vm.WriteInt(r.Index, w)
	if err != nil {
		return err
	}
	err = vm.WriteInt(r.Total, w)
	if err != nil {
		return err
	}
	err = vm.WriteBytes(r.OldColumnsBytes, w)
	if err != nil {
		return err
	}
	err = vm.WriteBytes(r.NewColumnsBytes, w)
	if err != nil {
		return err
	}
	return err
}

func (r *Record) Serialize(w io.Writer) error {
	return writeRecord(r, w)
}

func (r *Record) Schema() string {
	return "{\"fields\":[{\"doc\":\"unique id of this record in the whole stream\",\"name\":\"id\",\"type\":\"long\"},{\"doc\":\"protocol version\",\"name\":\"version\",\"type\":\"int\"},{\"aliases\":[\"operation\"],\"name\":\"messageType\",\"type\":{\"name\":\"MessageType\",\"namespace\":\"com.tencent.subscribe.avro\",\"symbols\":[\"INSERT\",\"UPDATE\",\"DELETE\",\"DDL\",\"BEGIN\",\"COMMIT\",\"HEARTBEAT\",\"CHECKPOINT\",\"ROLLBACK\",\"STATEMENT\",\"INIT_DDL\",\"INIT_INSERT\"],\"type\":\"enum\"}},{\"doc\":\"binlog file name\",\"name\":\"fileName\",\"type\":\"string\"},{\"aliases\":[\"sourceTimestamp\"],\"doc\":\"record log timestamp\",\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"gtid\",\"type\":\"string\"},{\"aliases\":[\"sourcePosition\"],\"doc\":\"end_log_pos of last event (exclude commit) in transaction\",\"name\":\"position\",\"type\":\"string\"},{\"aliases\":[\"safeSourcePosition\"],\"default\":\"\",\"doc\":\"end_log_pos of begin event in transaction\",\"name\":\"safePosition\",\"type\":\"string\"},{\"aliases\":[\"sourceTxid\"],\"default\":\"\",\"doc\":\"transaction id\",\"name\":\"transactionId\",\"type\":\"string\"},{\"name\":\"serverId\",\"type\":\"string\"},{\"name\":\"threadId\",\"type\":\"string\"},{\"aliases\":[\"source.sourceType\"],\"doc\":\"source database type\",\"name\":\"sourceType\",\"type\":\"string\"},{\"aliases\":[\"source.version\"],\"doc\":\"source database version\",\"name\":\"sourceVersion\",\"type\":\"string\"},{\"doc\":\"name of source schema if exist\",\"name\":\"schemaName\",\"type\":\"string\"},{\"doc\":\"name of source table if exist\",\"name\":\"tableName\",\"type\":\"string\"},{\"default\":\"\",\"doc\":\"schemaName.tableName\",\"name\":\"objectName\",\"type\":\"string\"},{\"aliases\":[\"fields\"],\"default\":null,\"name\":\"columns\",\"type\":[\"null\",{\"items\":{\"doc\":\"definition of column\",\"fields\":[{\"doc\":\"column names for table\",\"name\":\"name\",\"type\":\"string\"},{\"name\":\"dataTypeNumber\",\"type\":\"int\"},{\"name\":\"isKey\",\"type\":\"boolean\"},{\"doc\":\"datatype of this column in source db\",\"name\":\"originalType\",\"type\":\"string\"}],\"name\":\"Field\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},\"type\":\"array\"}]},{\"aliases\":[\"beforeImages\"],\"default\":null,\"doc\":\"values of a row before modify\",\"name\":\"oldColumns\",\"type\":[\"null\",\"bytes\",{\"items\":[\"null\",{\"doc\":\"defined Integer type in source db\",\"fields\":[{\"doc\":\"byte length of int\",\"name\":\"precision\",\"type\":\"int\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"Integer\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"charset\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"Character\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"doc\":\"defined decimal (or double) type in source db\",\"fields\":[{\"name\":\"value\",\"type\":\"string\"},{\"doc\":\"how many digits stored in total\",\"name\":\"precision\",\"type\":\"int\"},{\"doc\":\"how many digits after decimal point\",\"name\":\"scale\",\"type\":\"int\"}],\"name\":\"Decimal\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"doc\":\"defined Float type in source db\",\"fields\":[{\"name\":\"value\",\"type\":\"double\"},{\"doc\":\"how many digits stored in total\",\"name\":\"precision\",\"type\":\"int\"},{\"doc\":\"how many digits after decimal point\",\"name\":\"scale\",\"type\":\"int\"}],\"name\":\"Float\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"millis\",\"type\":\"int\"}],\"name\":\"Timestamp\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"default\":null,\"name\":\"year\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"month\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"day\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"hour\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"minute\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"second\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"millis\",\"type\":[\"null\",\"int\"]}],\"name\":\"DateTime\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"value\",\"type\":\"com.tencent.subscribe.avro.DateTime\"},{\"name\":\"timezone\",\"type\":\"string\"}],\"name\":\"TimestampWithTimeZone\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"BinaryGeometry\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"TextGeometry\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"BinaryObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"TextObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"name\":\"EmptyObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"symbols\":[\"NULL\",\"NONE\"],\"type\":\"enum\"}],\"type\":\"array\"}]},{\"aliases\":[\"afterImages\"],\"default\":null,\"doc\":\"values of a row after modify\",\"name\":\"newColumns\",\"type\":[\"null\",\"bytes\",{\"items\":[\"null\",\"com.tencent.subscribe.avro.Integer\",\"com.tencent.subscribe.avro.Character\",\"com.tencent.subscribe.avro.Decimal\",\"com.tencent.subscribe.avro.Float\",\"com.tencent.subscribe.avro.Timestamp\",\"com.tencent.subscribe.avro.DateTime\",\"com.tencent.subscribe.avro.TimestampWithTimeZone\",\"com.tencent.subscribe.avro.BinaryGeometry\",\"com.tencent.subscribe.avro.TextGeometry\",\"com.tencent.subscribe.avro.BinaryObject\",\"com.tencent.subscribe.avro.TextObject\",\"com.tencent.subscribe.avro.EmptyObject\"],\"type\":\"array\"}]},{\"doc\":\"ddl sql if this is a ddl event\",\"name\":\"sql\",\"type\":\"string\"},{\"doc\":\"execution time of ddl sql\",\"name\":\"executionTime\",\"type\":\"int\"},{\"doc\":\"timestamp of heartbeat send by master if this is a heartbeat record\",\"name\":\"heartbeatTimestamp\",\"type\":\"long\"},{\"name\":\"syncedGtid\",\"type\":\"string\"},{\"doc\":\"for some database that has no gtid, a fake gtid will be assigned\",\"name\":\"fakeGtid\",\"type\":\"boolean\"},{\"doc\":\"primary keys\",\"name\":\"pkNames\",\"type\":{\"items\":\"string\",\"type\":\"array\"}},{\"aliases\":[\"readerThroughoutTime\"],\"doc\":\"a millisecond timestamp. Not implemented at current version\",\"name\":\"readerTimestamp\",\"type\":\"long\"},{\"default\":{},\"doc\":\"tags to identify properties of this record\",\"name\":\"tags\",\"type\":{\"type\":\"map\",\"values\":\"string\"}},{\"default\":-1,\"doc\":\"Not implemented at current version\",\"name\":\"index\",\"type\":\"int\"},{\"default\":-1,\"doc\":\"Not implemented at current version\",\"name\":\"total\",\"type\":\"int\"},{\"default\":\"\",\"doc\":\"bytes value of oldColumns when record is too large to split\",\"name\":\"oldColumnsBytes\",\"type\":\"bytes\"},{\"default\":\"\",\"doc\":\"bytes value of newColumns when record is too large to split\",\"name\":\"newColumnsBytes\",\"type\":\"bytes\"}],\"name\":\"com.tencent.subscribe.avro.Record\",\"type\":\"record\"}"
}

func (r *Record) SchemaV6() string {
	return "{\"fields\":[{\"doc\":\"unique id of this record in the whole stream\",\"name\":\"id\",\"type\":\"long\"},{\"doc\":\"protocol version\",\"name\":\"version\",\"type\":\"int\"},{\"aliases\":[\"operation\"],\"name\":\"messageType\",\"type\":{\"name\":\"MessageType\",\"namespace\":\"com.tencent.subscribe.avro\",\"symbols\":[\"INSERT\",\"UPDATE\",\"DELETE\",\"DDL\",\"BEGIN\",\"COMMIT\",\"HEARTBEAT\",\"CHECKPOINT\",\"ROLLBACK\",\"STATEMENT\",\"INIT_DDL\",\"INIT_INSERT\"],\"type\":\"enum\"}},{\"doc\":\"binlog file name\",\"name\":\"fileName\",\"type\":\"string\"},{\"aliases\":[\"sourceTimestamp\"],\"doc\":\"record log timestamp\",\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"gtid\",\"type\":\"string\"},{\"aliases\":[\"sourcePosition\"],\"doc\":\"end_log_pos of last event (exclude commit) in transaction\",\"name\":\"position\",\"type\":\"string\"},{\"aliases\":[\"safeSourcePosition\"],\"default\":\"\",\"doc\":\"end_log_pos of begin event in transaction\",\"name\":\"safePosition\",\"type\":\"string\"},{\"aliases\":[\"sourceTxid\"],\"default\":\"\",\"doc\":\"transaction id\",\"name\":\"transactionId\",\"type\":\"string\"},{\"name\":\"serverId\",\"type\":\"string\"},{\"name\":\"threadId\",\"type\":\"string\"},{\"aliases\":[\"source.sourceType\"],\"doc\":\"source database type\",\"name\":\"sourceType\",\"type\":\"string\"},{\"aliases\":[\"source.version\"],\"doc\":\"source database version\",\"name\":\"sourceVersion\",\"type\":\"string\"},{\"doc\":\"name of source schema if exist\",\"name\":\"schemaName\",\"type\":\"string\"},{\"doc\":\"name of source table if exist\",\"name\":\"tableName\",\"type\":\"string\"},{\"default\":\"\",\"doc\":\"schemaName.tableName\",\"name\":\"objectName\",\"type\":\"string\"},{\"aliases\":[\"fields\"],\"default\":null,\"name\":\"columns\",\"type\":[\"null\",{\"items\":{\"doc\":\"definition of column\",\"fields\":[{\"doc\":\"column names for table\",\"name\":\"name\",\"type\":\"string\"},{\"name\":\"dataTypeNumber\",\"type\":\"int\"},{\"name\":\"isKey\",\"type\":\"boolean\"},{\"doc\":\"datatype of this column in source db\",\"name\":\"originalType\",\"type\":\"string\"}],\"name\":\"Field\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},\"type\":\"array\"}]},{\"aliases\":[\"beforeImages\"],\"default\":null,\"doc\":\"values of a row before modify. if values' size is over 20M, they will be discarded\",\"name\":\"oldColumns\",\"type\":[\"null\",\"bytes\",{\"items\":[\"null\",{\"doc\":\"defined Integer type in source db\",\"fields\":[{\"doc\":\"byte length of int\",\"name\":\"precision\",\"type\":\"int\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"Integer\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"charset\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"Character\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"doc\":\"defined decimal (or double) type in source db\",\"fields\":[{\"name\":\"value\",\"type\":\"string\"},{\"doc\":\"how many digits stored in total\",\"name\":\"precision\",\"type\":\"int\"},{\"doc\":\"how many digits after decimal point\",\"name\":\"scale\",\"type\":\"int\"}],\"name\":\"Decimal\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"doc\":\"defined Float type in source db\",\"fields\":[{\"name\":\"value\",\"type\":\"double\"},{\"doc\":\"how many digits stored in total\",\"name\":\"precision\",\"type\":\"int\"},{\"doc\":\"how many digits after decimal point\",\"name\":\"scale\",\"type\":\"int\"}],\"name\":\"Float\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"millis\",\"type\":\"int\"}],\"name\":\"Timestamp\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"default\":null,\"name\":\"year\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"month\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"day\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"hour\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"minute\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"second\",\"type\":[\"null\",\"int\"]},{\"default\":null,\"name\":\"millis\",\"type\":[\"null\",\"int\"]}],\"name\":\"DateTime\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"value\",\"type\":\"com.tencent.subscribe.avro.DateTime\"},{\"name\":\"timezone\",\"type\":\"string\"}],\"name\":\"TimestampWithTimeZone\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"BinaryGeometry\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"TextGeometry\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"bytes\"}],\"name\":\"BinaryObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"fields\":[{\"name\":\"type\",\"type\":\"string\"},{\"name\":\"value\",\"type\":\"string\"}],\"name\":\"TextObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"type\":\"record\"},{\"name\":\"EmptyObject\",\"namespace\":\"com.tencent.subscribe.avro\",\"symbols\":[\"NULL\",\"NONE\"],\"type\":\"enum\"}],\"type\":\"array\"}]},{\"aliases\":[\"afterImages\"],\"default\":null,\"doc\":\"values of a row after modify. if values' size is over 20M, they will be discarded\",\"name\":\"newColumns\",\"type\":[\"null\",\"bytes\",{\"items\":[\"null\",\"com.tencent.subscribe.avro.Integer\",\"com.tencent.subscribe.avro.Character\",\"com.tencent.subscribe.avro.Decimal\",\"com.tencent.subscribe.avro.Float\",\"com.tencent.subscribe.avro.Timestamp\",\"com.tencent.subscribe.avro.DateTime\",\"com.tencent.subscribe.avro.TimestampWithTimeZone\",\"com.tencent.subscribe.avro.BinaryGeometry\",\"com.tencent.subscribe.avro.TextGeometry\",\"com.tencent.subscribe.avro.BinaryObject\",\"com.tencent.subscribe.avro.TextObject\",\"com.tencent.subscribe.avro.EmptyObject\"],\"type\":\"array\"}]},{\"doc\":\"ddl sql if this is a ddl event\",\"name\":\"sql\",\"type\":\"string\"},{\"doc\":\"execution time of ddl sql\",\"name\":\"executionTime\",\"type\":\"int\"},{\"doc\":\"timestamp of heartbeat send by master if this is a heartbeat record\",\"name\":\"heartbeatTimestamp\",\"type\":\"long\"},{\"name\":\"syncedGtid\",\"type\":\"string\"},{\"doc\":\"for some database that has no gtid, a fake gtid will be assigned\",\"name\":\"fakeGtid\",\"type\":\"boolean\"},{\"doc\":\"primary keys\",\"name\":\"pkNames\",\"type\":{\"items\":\"string\",\"type\":\"array\"}},{\"aliases\":[\"readerThroughoutTime\"],\"doc\":\"a millisecond timestamp. Not implemented at current version\",\"name\":\"readerTimestamp\",\"type\":\"long\"},{\"default\":{},\"doc\":\"tags to identify properties of this record\",\"name\":\"tags\",\"type\":{\"type\":\"map\",\"values\":\"string\"}},{\"default\":-1,\"doc\":\"Not implemented at current version\",\"name\":\"index\",\"type\":\"int\"},{\"default\":-1,\"doc\":\"Not implemented at current version\",\"name\":\"total\",\"type\":\"int\"}],\"name\":\"com.tencent.subscribe.avro.Record\",\"type\":\"record\"}"
}

func (r *Record) SchemaName() string {
	return "com.tencent.subscribe.avro.Record"
}

func (_ *Record) SetBoolean(v bool)    { panic("Unsupported operation") }
func (_ *Record) SetInt(v int32)       { panic("Unsupported operation") }
func (_ *Record) SetLong(v int64)      { panic("Unsupported operation") }
func (_ *Record) SetFloat(v float32)   { panic("Unsupported operation") }
func (_ *Record) SetDouble(v float64)  { panic("Unsupported operation") }
func (_ *Record) SetBytes(v []byte)    { panic("Unsupported operation") }
func (_ *Record) SetString(v string)   { panic("Unsupported operation") }
func (_ *Record) SetUnionElem(v int64) { panic("Unsupported operation") }

func (r *Record) Get(i int) types.Field {
	switch i {
	case 0:
		return &types.Long{Target: &r.Id}
	case 1:
		return &types.Int{Target: &r.Version}
	case 2:
		return &MessageTypeWrapper{Target: &r.MessageType}
	case 3:
		return &types.String{Target: &r.FileName}
	case 4:
		return &types.Long{Target: &r.Timestamp}
	case 5:
		return &types.String{Target: &r.Gtid}
	case 6:
		return &types.String{Target: &r.Position}
	case 7:
		return &types.String{Target: &r.SafePosition}
	case 8:
		return &types.String{Target: &r.TransactionId}
	case 9:
		return &types.String{Target: &r.ServerId}
	case 10:
		return &types.String{Target: &r.ThreadId}
	case 11:
		return &types.String{Target: &r.SourceType}
	case 12:
		return &types.String{Target: &r.SourceVersion}
	case 13:
		return &types.String{Target: &r.Field_SchemaName}
	case 14:
		return &types.String{Target: &r.TableName}
	case 15:
		return &types.String{Target: &r.ObjectName}
	case 16:
		r.Columns = NewUnionNullArrayField()

		return r.Columns
	case 17:
		r.OldColumns = NewUnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject()

		return r.OldColumns
	case 18:
		r.NewColumns = NewUnionNullBytesArrayUnionNullIntegerCharacterDecimalFloatTimestampDateTimeTimestampWithTimeZoneBinaryGeometryTextGeometryBinaryObjectTextObjectEmptyObject()

		return r.NewColumns
	case 19:
		return &types.String{Target: &r.Sql}
	case 20:
		return &types.Int{Target: &r.ExecutionTime}
	case 21:
		return &types.Long{Target: &r.HeartbeatTimestamp}
	case 22:
		return &types.String{Target: &r.SyncedGtid}
	case 23:
		return &types.Boolean{Target: &r.FakeGtid}
	case 24:
		r.PkNames = make([]string, 0)

		return &ArrayStringWrapper{Target: &r.PkNames}
	case 25:
		return &types.Long{Target: &r.ReaderTimestamp}
	case 26:
		r.Tags = make(map[string]string)

		return &MapStringWrapper{Target: &r.Tags}
	case 27:
		return &types.Int{Target: &r.Index}
	case 28:
		return &types.Int{Target: &r.Total}
	case 29:
		return &types.Bytes{Target: &r.OldColumnsBytes}
	case 30:
		return &types.Bytes{Target: &r.NewColumnsBytes}
	}
	panic("Unknown field index")
}

func (r *Record) SetDefault(i int) {
	switch i {
	case 7:
		r.SafePosition = ""
		return
	case 8:
		r.TransactionId = ""
		return
	case 15:
		r.ObjectName = ""
		return
	case 16:
		r.Columns = nil
		return
	case 17:
		r.OldColumns = nil
		return
	case 18:
		r.NewColumns = nil
		return
	case 26:

		return
	case 27:
		r.Index = -1
		return
	case 28:
		r.Total = -1
		return
	case 29:
		r.OldColumnsBytes = []byte("")
		return
	case 30:
		r.NewColumnsBytes = []byte("")
		return
	}
	panic("Unknown field index")
}

func (r *Record) NullField(i int) {
	switch i {
	case 16:
		r.Columns = nil
		return
	case 17:
		r.OldColumns = nil
		return
	case 18:
		r.NewColumns = nil
		return
	}
	panic("Not a nullable field index")
}

func (_ *Record) AppendMap(key string) types.Field { panic("Unsupported operation") }
func (_ *Record) AppendArray() types.Field         { panic("Unsupported operation") }
func (_ *Record) Finalize()                        {}

func (_ *Record) AvroCRC64Fingerprint() []byte {
	return []byte(RecordAvroCRC64Fingerprint)
}
